﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Thomas_Erdoesi.Game_Analyzer
{
    public class GameConstants
    {
        public const int MinCoordX = 0;
        public const int MaxCoordX = 1023;
        public const int MinCoordY = 128;
        public const int MaxCoordY = 895;

        public const int SizeX = MaxCoordX - MinCoordX + 1;
        public const int SizeY = MaxCoordY - MinCoordY + 1;

        public const int CenterX = (MinCoordX + MaxCoordX) / 2;
        public const int CenterY = (MinCoordY + MaxCoordY) / 2;

        public const int MinDistX = -SizeX / 2;
        public const int MaxDistX = SizeX / 2;
        public const int MinDistY = -SizeY / 2;
        public const int MaxDistY = SizeY / 2;

        public static double[] ShipAngle = new double[] { 0,
                                                   0.0628318530717959,
                                                   0.143116998663535,
                                                   0.22165681500328,
                                                   0.287979326579064,
                                                   0.370009801422798,
                                                   0.439822971502571,
                                                   0.514872129338327,
                                                   0.5846852994181,
                                                   0.659734457253856,
                                                   0.727802298081635,
                                                   0.80634211442138,
                                                   0.886627260013119,
                                                   0.965167076352864,
                                                   1.03672557568463,
                                                   1.1065387457644,
                                                   1.17809724509617,
                                                   1.24965574442794,
                                                   1.32819556076768,
                                                   1.39451807234347,
                                                   1.47480321793521,
                                                   1.55508836352695,
                                                   1.61966554585074,
                                                   1.69646003293849,
                                                   1.77674517853023,
                                                   1.84132236085402,
                                                   1.92335283569775,
                                                   1.99142067652553,
                                                   2.0612338466053,
                                                   2.14326432144904,
                                                   2.21133216227682,
                                                   2.28812664936457,
                                                   2.35619449019234,
                                                   2.4329889772801,
                                                   2.50105681810787,
                                                   2.58134196369961,
                                                   2.65115513377939,
                                                   2.73318560862312,
                                                   2.80474410795489,
                                                   2.87106661953067,
                                                   2.95309709437441,
                                                   3.0159289474462,
                                                   3.09446876378595,
                                                  -3.1084313978019,
                                                  -3.0455995447301,
                                                  -2.96880505764235,
                                                  -2.88851991205062,
                                                  -2.82394272972683,
                                                  -2.7401669256311,
                                                  -2.67209908480332,
                                                  -2.60054058547155,
                                                  -2.5237460983838,
                                                  -2.44346095279206,
                                                  -2.37713844121628,
                                                  -2.31256125889249,
                                                  -2.23053078404875,
                                                  -2.16595360172496,
                                                  -2.08915911463721,
                                                  -2.00538331054148,
                                                  -1.94080612821769,
                                                  -1.87273828738992,
                                                  -1.79245314179818,
                                                  -1.72613063022239,
                                                  -1.64759081388265,
                                                  -1.5707963267949,
                                                  -1.5079644737231,
                                                  -1.42767932813136,
                                                  -1.34913951179162,
                                                  -1.28281700021583,
                                                  -1.2007865253721,
                                                  -1.13446401379631,
                                                  -1.06465084371654,
                                                  -0.986111027376796,
                                                  -0.911061869541039,
                                                  -0.842994028713261,
                                                  -0.764454212373517,
                                                  -0.698131700797732,
                                                  -0.619591884457987,
                                                  -0.548033385126219,
                                                  -0.476474885794452,
                                                  -0.408407044966673,
                                                  -0.321140582366956,
                                                  -0.256563400043166,
                                                  -0.176278254451428,
                                                  -0.0959931088596884,
                                                  -0.033161255787892,
                                                   0.0488692190558412,
                                                   0.125663706143592,
                                                   0.191986217719376,
                                                   0.270526034059121,
                                                   0.336848545634906,
                                                   0.408407044966673,
                                                   0.490437519810407,
                                                   0.57246799465414,
                                                   0.640535835481919,
                                                   0.708603676309698,
                                                   0.785398163397448,
                                                   0.862192650485199,
                                                   0.930260491312978,
                                                   0.998328332140757,
                                                   1.08035880698449,
                                                   1.16238928182822,
                                                   1.23394778115999,
                                                   1.30027029273578,
                                                   1.37881010907552,
                                                   1.4451326206513,
                                                   1.52192710773906,
                                                   1.60395758258279,
                                                   1.66678943565458,
                                                   1.74707458124632,
                                                   1.82735972683806,
                                                   1.89193690916185,
                                                   1.97920337176157,
                                                   2.04727121258935,
                                                   2.11882971192112,
                                                   2.19213354050488,
                                                   2.26892802759263,
                                                   2.33525053916841,
                                                   2.41379035550816,
                                                   2.48185819633594,
                                                   2.55690735417169,
                                                   2.63544717051144,
                                                   2.70526034059121,
                                                   2.771582852167,
                                                   2.85535865626272,
                                                   2.91993583858651,
                                                   2.99847565492626,
                                                   3.08225145902199,
                                                   3.14159265358979,
                                                  -3.06479816650204,
                                                  -2.9862583501623,
                                                  -2.91993583858651,
                                                  -2.83965069299477,
                                                  -2.771582852167,
                                                  -2.70526034059121,
                                                  -2.62322986574748,
                                                  -2.54469004940773,
                                                  -2.48185819633594,
                                                  -2.3998277214922,
                                                  -2.33525053916841,
                                                  -2.26892802759263,
                                                  -2.18864288200089,
                                                  -2.11184839491314,
                                                  -2.04028989558137,
                                                  -1.97222205475359,
                                                  -1.88844625065786,
                                                  -1.82386906833407,
                                                  -1.74358392274234,
                                                  -1.66678943565458,
                                                  -1.60395758258279,
                                                  -1.52367243699105,
                                                  -1.4451326206513,
                                                  -1.38230076757951,
                                                  -1.30027029273578,
                                                  -1.23394778115999,
                                                  -1.16238928182822,
                                                  -1.08035880698449,
                                                  -1.00880030765272,
                                                  -0.930260491312977,
                                                  -0.862192650485198,
                                                  -0.785398163397448,
                                                  -0.71733032256967,
                                                  -0.640535835481918,
                                                  -0.57246799465414,
                                                  -0.490437519810407,
                                                  -0.420624349730634,
                                                  -0.352556508902854,
                                                  -0.270526034059121,
                                                  -0.205948851735331,
                                                  -0.125663706143591,
                                                  -0.0488692190558409,
                                                   0.015707963267949,
                                                   0.0959931088596881,
                                                   0.176278254451427,
                                                   0.242600766027212,
                                                   0.321140582366957,
                                                   0.392699081698724,
                                                   0.464257581030492,
                                                   0.534070751110265,
                                                   0.605629250442032,
                                                   0.684169066781777,
                                                   0.764454212373516,
                                                   0.842994028713261,
                                                   0.91106186954104,
                                                   0.986111027376796,
                                                   1.05592419745657,
                                                   1.12922802604033,
                                                   1.2007865253721,
                                                   1.28281700021583,
                                                   1.34913951179162,
                                                   1.42767932813136,
                                                   1.5079644737231,
                                                   1.5707963267949,
                                                   1.64933614313464,
                                                   1.72613063022239,
                                                   1.79245314179818,
                                                   1.87273828738992,
                                                   1.94080612821769,
                                                   2.01236462754946,
                                                   2.09788576089718,
                                                   2.16769893097696,
                                                   2.23053078404875,
                                                   2.31256125889249,
                                                   2.37539311196428,
                                                   2.45742358680802,
                                                   2.53596340314776,
                                                   2.61450321948751,
                                                   2.68606171881927,
                                                   2.75587488889905,
                                                   2.82394272972683,
                                                   2.90248254606657,
                                                   2.96880505764235,
                                                   3.04210888622612,
                                                   3.12588469032184,
                                                  -3.09097810528196,
                                                  -3.0159289474462,
                                                  -2.94087978961045,
                                                  -2.86932129027868,
                                                  -2.78729081543494,
                                                  -2.72096830385916,
                                                  -2.65115513377939,
                                                  -2.58134196369961,
                                                  -2.50280214735987,
                                                  -2.42600766027212,
                                                  -2.35619449019234,
                                                  -2.28812664936457,
                                                  -2.21133216227682,
                                                  -2.13279234593707,
                                                  -2.0612338466053,
                                                  -1.99142067652553,
                                                  -1.92335283569775,
                                                  -1.84132236085402,
                                                  -1.77325452002624,
                                                  -1.69646003293849,
                                                  -1.61792021659874,
                                                  -1.55508836352695,
                                                  -1.47480321793521,
                                                  -1.39800873084746,
                                                  -1.33168621927167,
                                                  -1.25314640293193,
                                                  -1.18507856210415,
                                                  -1.11526539202438,
                                                  -1.04370689269261,
                                                  -0.965167076352865,
                                                  -0.886627260013119,
                                                  -0.80634211442138,
                                                  -0.74176493209759,
                                                  -0.659734457253856,
                                                  -0.59690260418206,
                                                  -0.527089434102288,
                                                  -0.441568300754565,
                                                  -0.370009801422798,
                                                  -0.301941960595019,
                                                  -0.223402144255274,
                                                  -0.155334303427495,
                                                  -0.0785398163397444 };
    }
}
